<?php

class AuthGalette {
	
	// Available fields (warning: encoded in ISO-8859-1)
	// Champs disponibles (attention : le codage est ISO-8859-1)
	protected $fields;
	
	// Admin ?
	private $admin;
	
	function __construct() {
		$this->fields = array();
		$this->admin = false;
	}
	
	/**
	 * Add a couple field/value
	 * Ajouter un couple champ/valeur
	 * 
	 * @param string $field: identifier of the field
	 * @param string $value: value of the field
	 * @return bool
	 * @private
	 */
	function addField( $field, $value ) {
		$this->fields[$field] = $value;
		//print $field."->".$value."\n";
		return true;
	}
	
	/**
	 * Get the value of a field
	 * Obtenir la valeur d'un champ
	 * 
	 * @param string $field: identifier of the field
	 * @return string
	 * @protected
	 */
	protected function getField( $field ) {
		return $this->fields[$field];
	}
	
	/**
	 * The user is an administrator
	 * L'utilisateur est un administrateur
	 * 
	 * @return bool
	 * @private
	 */
	function isAdmin() {
		$this->admin = true;
		return true;
	}
	
	/**
	 * Is the user an administrator ?
	 * L'utilisateur est un administrateur ?
	 * 
	 * @return bool
	 * @protected
	 */
	protected function getAdmin() {
		return $this->admin;
	}
	
	/**
	 * Add a user in the external database
	 * Ajouter un utilisateur dans la base de donnes externe
	 * 
	 * @return bool
	 * @public
	 */
	function addExternalUser() {
		# Override this!
		return true;
	}
	
	/**
	 * Update the external database
	 * Mettre  jour la base de donnes externe
	 * 
	 * @return bool
	 * @public
	 */
	function updateExternalUser() {
		# Override this!
		return true;
	}
	
}

